<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
<link rel="STYLESHEET" href="howto.css" type='text/css' />
<link rel="first" href="howto.html" title='Developing applications with Kiwi' />
<link rel='last' href='about.html' title='About this document...' />
<link rel='help' href='about.html' title='About this document...' />
<link rel="next" href="node26.html" />
<link rel="prev" href="node1.html" />
<link rel="parent" href="howto.html" />
<link rel="next" href="node6.html" />
<meta name='aesop' content='information' />
<title>2 The Kiwi FrameWork</title>
</head>
<body>
<DIV CLASS="navigation">
<div id='top-navigation-panel' xml:id='top-navigation-panel'>
<table align="center" width="100%" cellpadding="0" cellspacing="2">
<tr>
<td class='online-navigation'><a rel="prev" title="1.3 Getting and Installing"
  href="node4.html"><img src='previous.png'
  border='0' height='32'  alt='Previous Page' width='32' /></A></td>
<td class='online-navigation'><a rel="parent" title="Developing applications with Kiwi"
  href="howto.html"><img src='up.png'
  border='0' height='32'  alt='Up One Level' width='32' /></A></td>
<td class='online-navigation'><a rel="next" title="2.1 Introduction"
  href="node6.html"><img src='next.png'
  border='0' height='32'  alt='Next Page' width='32' /></A></td>
<td align="center" width="100%">Developing applications with Kiwi</td>
<td class='online-navigation'><img src='blank.png'
  border='0' height='32'  alt='' width='32' /></td>
<td class='online-navigation'><img src='blank.png'
  border='0' height='32'  alt='' width='32' /></td>
<td class='online-navigation'><img src='blank.png'
  border='0' height='32'  alt='' width='32' /></td>
</tr></table>
<div class='online-navigation'>
<b class="navlabel">Previous:</b>
<a class="sectref" rel="prev" href="node4.html">1.3 Getting and Installing</A>
<b class="navlabel">Up:</b>
<a class="sectref" rel="parent" href="howto.html">Developing applications with Kiwi</A>
<b class="navlabel">Next:</b>
<a class="sectref" rel="next" href="node6.html">2.1 Introduction</A>
</div>
<hr /></div>
</DIV>
<!--End of Navigation Panel-->

<H1><A NAME="SECTION000200000000000000000"></A>
<A NAME="person"></A>
<BR>
2 The Kiwi FrameWork
</H1>

<P>
This section introduces the Kiwi framework, and shows the use cases that
each of the main classes were designed for. Throughout this guide, I'll
be showing code examples that are included in the distribution (in the
<span class="file">examples/</span> directory); just install Kiwi and you are ready to run
them. To start off with, I'll show a very simple Kiwi application that
saves information defined in a graphical form. This app is included in
<span class="file">examples/framework/person/person.py</span>.  Note that this app uses the
glade file <em class="citetitle"><a
 href="Person.glade"
 title="Person.glade"
 >Person.glade</a></em>.

<P>
<DIV ALIGN="CENTER">
<IMG
  ALIGN="BOTTOM" BORDER="0"
 SRC="img2.png"
 ALT="\includegraphics[scale=0.905]{images/simple.eps}">

</DIV>

<P>
<BR>
<PRE  CLASS="verbatim">#!/usr/bin/env python
import gtk
from kiwi.model import PickledModel
from kiwi.ui.delegates import ProxyDelegate

# define the class that holds our application data
class Person(PickledModel):
    pass
person = Person.unpickle()

# create and run a proxy interface attached to person
view = ProxyDelegate(person, gladefile="Person",
                     widgets=["address", 'name', 'phone'],
                     delete_handler=gtk.main_quit)
view.focus_topmost()
view.show_and_loop()

# save changes done to the instance
person.save()
</PRE>
<P>
This application (17 lines) renders an interface to edit personal data,
transparently saving and loading it. A quick glance at the code:

<P>

<OL>
<LI>We define Person, a class to hold our application information
</LI>
<LI><code>Person.unpickle()</code> loads (creating, if it didn't exist) a
Person instance.
</LI>
<LI>We create a <tt class="class">ProxyDelegate</tt> instance, which loads an interface
from a glade definition file and attaches it to the Person instance.
</LI>
<LI>We run the application; changes in the interface reflect
transparently on the person instance.
</LI>
<LI>Upon exiting the mainloop, the window closes and we save the
person. It is ready to be edited the next time we run the program.
</LI>
</OL>

<P>
This example is a summary of many Kiwi features; it exemplifies the
Proxy class, which is one of the more featureful parts of the
framework. This guide will take you gradually through the different
classes in Kiwi, and the next section begins by describing the general
Kiwi architecture.

<P>

<p><br /></p><hr class='online-navigation' />
<div class='online-navigation'>
<!--Table of Child-Links-->
<A NAME="CHILD_LINKS"><STRONG>Subsections</STRONG></a>

<UL CLASS="ChildLinks">
<LI><A href="node6.html">2.1 Introduction</a>
<LI><A href="node7.html">2.2 The FrameWork Classes</a>
<LI><A href="node8.html">2.3 Views</a>
<LI><A href="node9.html">2.4 BaseView</a>
<LI><A href="node10.html">2.5 UI Composition</a>
<LI><A href="callbacks.html">2.6 Controllers</a>
<UL>
<LI><A href="node12.html">2.6.1 Default Widget Focus</a>
<LI><A href="node13.html">2.6.2 Advanced Controllers</a>
</ul>
<LI><A href="node14.html">2.7 UI Delegates</a>
<LI><A href="node15.html">2.8 UI Composition with Delegates (or Views and Controllers)</a>
<LI><A href="node16.html">2.9 Proxies and Models</a>
<UL>
<LI><A href="node17.html">2.9.1 Domain Objects (or Models)</a>
<LI><A href="node18.html">2.9.2 Using Proxies</a>
<LI><A href="node19.html">2.9.3 Propagating changes from Model to Proxy</a>
<LI><A href="node20.html">2.9.4 Customizing Proxies and Models</a>
<LI><A href="node21.html">2.9.5 Using Signal Handlers in Proxies</a>
<LI><A href="node22.html">2.9.6 Widget support in Proxies</a>
<LI><A href="node23.html">2.9.7 Models</a>
<LI><A href="multipleproxies.html">2.9.8 Multiple Proxies</a>
<LI><A href="undo.html">2.9.9 Other Proxy features</a>
<UL>
<LI><A href="undo.html#SECTION000299100000000000000">2.9.9.1 Types</a>
<LI><A href="undo.html#SECTION000299200000000000000">2.9.9.2 Formats</a>
<LI><A href="undo.html#SECTION000299300000000000000">2.9.9.3 "Instant-apply" and Undo</a>
<LI><A href="undo.html#SECTION000299400000000000000">2.9.9.4 Proxy startup values</a>
</ul></ul></ul>
<!--End of Table of Child-Links-->
</div>

<DIV CLASS="navigation">
<div class='online-navigation'>
<p></p><hr />
<table align="center" width="100%" cellpadding="0" cellspacing="2">
<tr>
<td class='online-navigation'><a rel="prev" title="1.3 Getting and Installing"
  href="node4.html"><img src='previous.png'
  border='0' height='32'  alt='Previous Page' width='32' /></A></td>
<td class='online-navigation'><a rel="parent" title="Developing applications with Kiwi"
  href="howto.html"><img src='up.png'
  border='0' height='32'  alt='Up One Level' width='32' /></A></td>
<td class='online-navigation'><a rel="next" title="2.1 Introduction"
  href="node6.html"><img src='next.png'
  border='0' height='32'  alt='Next Page' width='32' /></A></td>
<td align="center" width="100%">Developing applications with Kiwi</td>
<td class='online-navigation'><img src='blank.png'
  border='0' height='32'  alt='' width='32' /></td>
<td class='online-navigation'><img src='blank.png'
  border='0' height='32'  alt='' width='32' /></td>
<td class='online-navigation'><img src='blank.png'
  border='0' height='32'  alt='' width='32' /></td>
</tr></table>
<div class='online-navigation'>
<b class="navlabel">Previous:</b>
<a class="sectref" rel="prev" href="node4.html">1.3 Getting and Installing</A>
<b class="navlabel">Up:</b>
<a class="sectref" rel="parent" href="howto.html">Developing applications with Kiwi</A>
<b class="navlabel">Next:</b>
<a class="sectref" rel="next" href="node6.html">2.1 Introduction</A>
</div>
</div>
<hr />
<span class="release-info">Release 1.9.22, documentation updated on August, 2006.</span>
</DIV>
<!--End of Navigation Panel-->

</BODY>
</HTML>
